import http from "../http-common";
import store from "../store/index";

class DataService {
  async fetchCitizenInformationBasedOnSSN(citizenSSN: any): Promise<Boolean> {
    const citizenData : any = await http.post('home/:ssn', { citizenSSN });
    return citizenData.data.length === 0 ? false : this.setCitizenInformation(citizenData)
  }

  //All data has to be stored from here (Exception Handling)
  setCitizenInformation(citizenInformation: any) : boolean {
    store.dispatch("citizenProfile", [
      citizenInformation.data.citizenData.first_name,
      citizenInformation.data.citizenData.last_name,
      citizenInformation.data.citizenData.age,
      citizenInformation.data.citizenData.ssn
    ]);
    //store.dispatch("assistiveAids", citizenInformation.data.citizenData.Assistive_Aids);
    store.dispatch("trainingPlans", citizenInformation.data.citizenData.Training_Plans);
    store.dispatch("homeCare", citizenInformation.data.citizenData.Home_Care);
    store.dispatch("registeredFalls", citizenInformation.data.citizenData.Registered_Falls);

    store.dispatch("probabilityComplete", citizenInformation.data.citizenPrediction.CompleteProb);
    store.dispatch("probabilityFall", citizenInformation.data.citizenPrediction.FallProb);
    store.dispatch("compliance", citizenInformation.data.citizenPrediction.ComplianceProb);
    store.dispatch("arguments", citizenInformation.data.citizenPrediction.Arguments);
    store.dispatch("shapComplete", citizenInformation.data.citizenPrediction.CompleteShapValues);
    store.dispatch("shapFall", citizenInformation.data.citizenPrediction.FallShapValues);
    return true;
  }
}

export default new DataService();
